package com.example.onomatopoeiaback.service;


import com.example.onomatopoeiaback.domain.employee.Employee;
import com.example.onomatopoeiaback.domain.visit.Visit;
import com.example.onomatopoeiaback.domain.visit.VisitDTO;
import com.example.onomatopoeiaback.exceptions.BadRequestException;
import com.example.onomatopoeiaback.exceptions.UnauthorizedException;
import com.example.onomatopoeiaback.repository.EmployeeRepository;
import com.example.onomatopoeiaback.repository.QrCodeRepository;
import com.example.onomatopoeiaback.repository.VisitRepository;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.temporal.ChronoUnit;

@Service
public class VisitService {
    private final VisitRepository visitRepository;
    private final EmployeeRepository employeeRepository;
    final
    QrCodeRepository qrCodeRepository;

    public VisitService(VisitRepository visitRepository, EmployeeRepository employeeRepository, QrCodeRepository qrCodeRepository) {
        this.visitRepository = visitRepository;
        this.employeeRepository = employeeRepository;
        this.qrCodeRepository = qrCodeRepository;
    }

//    TDDO: удалить это. и оставить open и доработать его. После этого объект Visit добавить пользователю в массив посещений. Реализовать получение посещений с offset и limit. Реализовать авторизацию и разделение методов на роли.
    public Visit create(VisitDTO visitDTO)  {
        Visit visit = new Visit();
        visit.setQrCode(qrCodeRepository.getReferenceById(visitDTO.getQrCodeId()));
        visit.setVisitType(visitDTO.getVisitType());
        return visitRepository.saveAndFlush(visit);
    }

    public void open(String login, VisitDTO visitDTO) {
        Visit visit = visitRepository.getVisitByValue(visitDTO.getValue());
        Employee employee = employeeRepository.getEmployeesByLogin(login);

        if (employee == null) {
            throw new UnauthorizedException();
        }
        else if (visit == null) {
            throw new BadRequestException();
        }

        LocalDateTime localDateTime = LocalDateTime.now().truncatedTo(ChronoUnit.SECONDS);
        employee.setLastVisit(localDateTime);
        employeeRepository.saveAndFlush(employee);
    }
}
